# frozen_string_literal: true
module Modelur
  ruby_version_number = RUBY_VERSION.split('.')[0..1].join('')
  extension = if RUBY_PLATFORM.include?('mingw')
                'so'
              elsif RUBY_PLATFORM.include?('darwin')
                'bundle'
              end
  clipper_file =  "clipper_#{ruby_version_number}.#{extension}"
  require_relative(File.join('clipper', clipper_file)) unless defined? Clipper
end
