# RubyEncoder v2.7 loader
version = RUBY_VERSION.scan(/^\d+\.\d+\.\d+/)[0].delete('.')[0..1]
arch, os = RUBY_PLATFORM.scan(/([A-Za-z0-9_]+)-([A-Za-z_]+)/)[0]
os = "mingw" if os == "mswin" # SketchUp 21
os == "mingw" ? ext = ".so" : ext = ".bundle"
file = __FILE__.dup
file.force_encoding('UTF-8') if file.respond_to?(:force_encoding)
path = File.expand_path(File.dirname(file))
%W[#{version}.#{os}.#{arch} #{version}.#{os}].each do |filename|
  filepath = File.join(path, "rgloader#{filename}")
  # puts filepath + ext + "\n"
  $LOADED_FEATURES.reject! { |p| p.dup.force_encoding('UTF-8').start_with?(filepath) }
  # Skip file loading if the file doesn't exist
  # https://gitlab.com/agilicity/dev/modelur-for-sketchup/-/issues/635
  next unless File.exist?(filepath + ext)
  begin
    require filepath and break
  rescue LoadError
    # We use rescue as flow control. And therefore don't handle errors.
  end
end
unless defined?(RGLoader)
  raise LoadError, "The RubyEncoder loader is not installed. Please visit the https://www.rubyencoder.com/loaders/ RubyEncoder site to download the required loader for '" + os + "' and unpack it into '" + path + "' directory to run this protected script."
end
